## aHR0cHM6Ly9naXRodWIuY29tL2ZhY3Rvci9mYWN0b3IvYXJjaGl2ZS9yZWZzL3RhZ3Mvc2ltaWxhci0wLjg2LnppcA

=== Makefile ===
CC = gcc

BINARY = f
IMAGE = factor.image
BUNDLE = Factor.app
VERSION = 0.86
DISK_IMAGE_DIR = Factor-$(VERSION)
DISK_IMAGE = Factor-$(VERSION).dmg
LIBPATH = -L/usr/X11R6/lib

ifdef DEBUG
	CFLAGS = -pg -O1
	STRIP = touch
else
	CFLAGS = -Wall -O3 -ffast-math -fomit-frame-pointer $(SITE_CFLAGS)
	STRIP = strip
endif

ifdef CONFIG
	include $(CONFIG)
endif

OBJS = $(PLAF_OBJS) \
	vm/alien.o \
	vm/bignum.o \
	vm/compiler.o \
	vm/debug.o \
	vm/factor.o \
	vm/ffi_test.o \
	vm/image.o \
	vm/io.o \
	vm/math.o \
	vm/data_gc.o \
	vm/code_gc.o \
	vm/primitives.o \
	vm/run.o \
	vm/stack.o \
	vm/types.o

default:
	@echo "Run 'make' with one of the following parameters:"
	@echo ""
	@echo "freebsd"
	@echo "linux-x86"
	@echo "linux-amd64"
	@echo "linux-ppc"
	@echo "macosx-x86"
	@echo "macosx-ppc"
	@echo "solaris"
	@echo "windows"
	@echo ""
	@echo "On Unix, pass NO_UI=1 if you don't want to link with the"
	@echo "X11 and OpenGL libraries."
	@echo ""
	@echo "On Mac OS X, pass X11=1 if you want to link with the"
	@echo "X11 library instead of Cocoa. You will also need to bootstrap"
	@echo "Factor with the -no-cocoa -x11 switches."
	@echo
	@echo "Also, you might want to set the SITE_CFLAGS environment"
	@echo "variable to enable some CPU-specific optimizations; this"
	@echo "can make a huge difference. Eg:"
	@echo ""
	@echo "export SITE_CFLAGS=\"-march=pentium4 -ffast-math\""

freebsd:
	$(MAKE) $(BINARY) CONFIG=vm/Config.freebsd

macosx-freetype:
	ln -sf libfreetype.6.dylib \
		Factor.app/Contents/Frameworks/libfreetype.dylib

macosx-ppc: macosx-freetype
	$(MAKE) $(BINARY) CONFIG=vm/Config.macosx.ppc

macosx-x86: macosx-freetype
	$(MAKE) $(BINARY) CONFIG=vm/Config.macosx

linux-x86:
	$(MAKE) $(BINARY) CONFIG=vm/Config.linux
	$(STRIP) $(BINARY)

linux-amd64:
	$(MAKE) $(BINARY) CONFIG=vm/Config.linux.amd64
	$(STRIP) $(BINARY)

linux-ppc:
	$(MAKE) $(BINARY) CONFIG=vm/Config.linux.ppc
	$(STRIP) $(BINARY)

solaris solaris-x86 solaris-amd64:
	$(MAKE) $(BINARY) CONFIG=vm/Config.solaris
	$(STRIP) $(BINARY)

windows:
	$(MAKE) $(BINARY) CONFIG=vm/Config.windows

macosx.app:
	cp $(BINARY) $(BUNDLE)/Contents/MacOS/Factor

	install_name_tool \
		-id @executable_path/../Frameworks/libfreetype.6.dylib \
		Factor.app/Contents/Frameworks/libfreetype.6.dylib
	install_name_tool \
		-change /usr/X11R6/lib/libfreetype.6.dylib \
		@executable_path/../Frameworks/libfreetype.6.dylib \
		Factor.app/Contents/MacOS/Factor

macosx.dmg:
	rm -f $(DISK_IMAGE)
	rm -rf $(DISK_IMAGE_DIR)
	mkdir $(DISK_IMAGE_DIR)
	mkdir -p $(DISK_IMAGE_DIR)/Factor/
	cp -R $(BUNDLE) $(DISK_IMAGE_DIR)/Factor/$(BUNDLE)
	chmod +x cp_dir
	cp factor.image license.txt README.txt TODO.FACTOR.txt \
		$(DISK_IMAGE_DIR)/Factor/
	find doc library contrib examples fonts \( -name '*.factor' \
		-o -name '*.facts' \
		-o -name '*.txt' \
		-o -name '*.html' \
		-o -name '*.ttf' \
		-o -name '*.el' \
		-o -name '*.vim' \
		-o -name '*.fgen' \
		-o -name '*.tex' \
		-o -name '*.fhtml' \
		-o -name '*.xml' \
		-o -name '*.js' \) \
		-exec ./cp_dir {} $(DISK_IMAGE_DIR)/Factor/{} \;
	hdiutil create -srcfolder "$(DISK_IMAGE_DIR)" -fs HFS+ \
		-volname "$(DISK_IMAGE_DIR)" "$(DISK_IMAGE)"

tags:
	ctags-exuberant vm/*.[chm]

f: $(OBJS)
	$(CC) $(LIBS) $(LIBPATH) $(CFLAGS) -o $@$(PLAF_SUFFIX) $(OBJS)

clean:
	rm -f vm/*.o

clean.app:
	rm -rf $(BUNDLE)/Contents/Resources/
	rm -f $(BUNDLE)/Contents/MacOS/Factor

.c.o:
	$(CC) -c $(CFLAGS) -o $@ $<

.S.o:
	$(CC) -c $(CFLAGS) -o $@ $<

.m.o:
	$(CC) -c $(CFLAGS) -o $@ $<

=== debian/changelog ===
factor (0.80) unstable; urgency=low

  * New stable release.

 -- Trent Buck <trentbuck@gmail.com>  Tue, 31 Jan 2006 21:11:15 +1100

factor (0.79+cvs20060120-1) unstable; urgency=low

  * Refactored wrapper scripts and reduced build time.

 -- Trent Buck <trentbuck@gmail.com>  Fri, 20 Jan 2006 12:18:21 +1100

factor (0.79+cvs20060119-1) unstable; urgency=low

  * Make an extended.image.

 -- Trent Buck <trentbuck@gmail.com>  Wed, 18 Jan 2006 00:14:02 +1100

factor (0.79+cvs20060117-1) unstable; urgency=low

  * Bootstrap from an already-installed binary.

 -- Trent Buck <trentbuck@gmail.com>  Tue, 17 Jan 2006 10:24:10 +1100

factor (0.79+cvs20060114-1) unstable; urgency=low

  * Initial release Closes: #nnnn  (nnnn is the bug number of your ITP)

 -- Trent Buck <trentbuck@gmail.com>  Sat, 14 Jan 2006 10:17:28 +1100

=== debian/control ===
Source: factor
Section: devel
Priority: optional
Maintainer: Trent Buck <trentbuck@gmail.com>
Build-Depends: factor, debhelper (>= 4.0.0), rubber, tetex-bin, tetex-extra, gs, sqlite3, libsdl1.2-dev, libfreetype6-dev, libsdl-gfx1.2-dev, libcairo2-dev, libsqlite3-dev, libx11-dev, libpq-dev
Standards-Version: 3.6.2

Package: factor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libsdl1.2-dev, libfreetype6-dev, libcairo2-dev, libsqlite3-dev, libx11-dev, libpq-dev
Suggests: rlwrap
Description: compiler for the concatenative language Factor
 Factor is a dynamic programming language. The end goal is to have a high
 performance, robust language for general-purpose client-side and server-side
 application development.
 .
 Factor is a natural evolution of Forth, combining Forth's simplicity and
 minimalism with a dynamically typed runtime supporting a Lisp-style object
 model and meta-programming. Factor also builds upon ideas from Joy, K, and
 Slate.
 .
 http://factorcode.org

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# SITE_CFLAGS=-fPIC -ffast-math -funsigned-char -mpowerpc -mpowerpc-gpopt -mpowerpc-gfxopt -maltivec -mabi=altivec -mtune=G4 -mcpu=G4 -pipe
# SITE_CFLAGS=-march=pentium4

VERSION=0.80
FARCH=$(shell sh debian/architecture.sh)

configure: configure-stamp

configure-stamp:
	dh_testdir
	touch configure-stamp

build: build-stamp

build-stamp: configure-stamp
	dh_testdir
	# Build the bootstrap image
	$(MAKE) linux-$(FARCH)
	mv f runtime
	echo 'USE: image "$(FARCH)" make-image' | ./runtime /usr/lib/factor/basic.image # || wget http://factorcode.org/boot.image.$(FARCH)
	mv boot.image.$(FARCH) boot.image
	# Build the factor image
	./runtime boot.image -libraries:sdl:name=libSDL.so -libraries:freetype:name=libfreetype.so
	mv factor.image basic.image
	# Build the extended image
	sqlite3 contrib/sqlite/test.db < contrib/sqlite/test.txt
	echo 'USING: image kernel ; "contrib/load.factor" run-file compile-all "extended.image" save-image 0 exit' | ./runtime basic.image +X8
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	-$(MAKE) clean
	-rm -f f runtime factor.image boot.image boot.image.$(FARCH) basic.image extended.image
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	# Install binary files
	install -m 755 -o root -g root runtime $(CURDIR)/debian/factor/usr/lib/factor
	install -m 644 -o root -g root boot.image basic.image extended.image $(CURDIR)/debian/factor/usr/lib/factor
	# Install source files
	cp -r contrib examples fonts library version.factor $(CURDIR)/debian/factor/usr/share/factor
	find $(CURDIR)/debian/factor/usr/share/factor -type d -exec chmod 755 {} \;
	find $(CURDIR)/debian/factor/usr/share/factor -type f -exec chmod 644 {} \;
	chown -R root.root $(CURDIR)/debian/factor/usr/share/factor
	# Install wrapper scripts
	install -m 755 -o root -g root debian/scripts/factor-* $(CURDIR)/debian/factor/usr/bin

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES.html
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
